(function() {
var GridViewToolbarCommandType = {
 FullExpand: "FullExpand",
 FullCollapse: "FullCollapse",
 ClearSorting: "ClearSorting",
 ShowFilterBuilder: "ShowFilterEditor",
 ShowFilterRow: "ShowFilterRow",
 ClearFilter: "ClearFilter",
 ShowFilterRowMenu: "ShowFilterRowMenu",
 ClearGrouping: "ClearGrouping",
 ShowGroupPanel: "ShowGroupPanel",
 ShowSearchPanel: "ShowSearchPanel",
 ShowCustomizationWindow: "ShowCustomizationWindow",
 ShowFooter: "ShowFooter",
 ShowCustomizationDialog: "ShowCustomizationDialog",
 ExpandRow: "ExpandRow",
 CollapseRow: "CollapseRow",
 ExpandDetailRow: "ExpandDetailRow",
 CollapseDetailRow: "CollapseDetailRow",
 New: "New",
 Edit: "Edit",
 Delete: "Delete",
 DeleteSelectedRowsOnPage: "DeleteSelectedRowsOnPage",
 Refresh: "Refresh",
 Update: "Update",
 Cancel: "Cancel"
};
var GridViewToolbarHelper = ASPx.CreateClass(ASPx.GridToolbarHelper, {
 constructor: function(grid) {
  this.constructor.prototype.constructor.call(this, grid);
 },
 ProcessToolbarItemClick: function(e) {
  var item = e.item,
   command = this.GetItemCommand(item);
  switch(command) {
   case GridViewToolbarCommandType.FullExpand:
    this.grid.ExpandAll();
    break;
   case GridViewToolbarCommandType.FullCollapse:
    this.grid.CollapseAll();
    break;
   case GridViewToolbarCommandType.ClearSorting:
    this.ToolbarClearSorting();
    break;
   case GridViewToolbarCommandType.ShowFilterBuilder:
    this.grid.ShowFilterControl();
    break;
   case GridViewToolbarCommandType.ShowFilterRow:
    this.ToolbarShowFilterRow(item.GetChecked());
    break;
   case GridViewToolbarCommandType.ClearFilter:
    this.grid.ClearFilter();
    break;
   case GridViewToolbarCommandType.ShowFilterRowMenu:
    this.ToolbarShowFilterRowMenu(item.GetChecked());
    break;
   case GridViewToolbarCommandType.ShowGroupPanel:
    this.ToolbarShowGroupPanel(item.GetChecked());
    break;
   case GridViewToolbarCommandType.ShowSearchPanel:
    this.ToolbarShowSearchPanel(item.GetChecked());
    break;
   case GridViewToolbarCommandType.ShowCustomizationWindow:
    if(!this.grid.IsCustomizationWindowVisible())
     this.grid.ShowCustomizationWindow();
    else
     this.grid.HideCustomizationWindow();
    break;
   case GridViewToolbarCommandType.ShowFooter:
    this.ToolbarShowFooter(item.GetChecked());
    break;
   case GridViewToolbarCommandType.ShowCustomizationDialog:
    this.grid.ShowCustomizationDialog();
    break;
   case GridViewToolbarCommandType.ExpandRow:
    this.grid.ExpandRow(this.grid.GetFocusedRowIndex());
    break;
   case GridViewToolbarCommandType.CollapseRow:
    this.grid.CollapseRow(this.grid.GetFocusedRowIndex());
    break;
   case GridViewToolbarCommandType.ExpandDetailRow:
    this.grid.ExpandDetailRow(this.grid.GetFocusedRowIndex());
    break;
   case GridViewToolbarCommandType.CollapseDetailRow:
    this.grid.CollapseDetailRow(this.grid.GetFocusedRowIndex());
    break;
   case GridViewToolbarCommandType.New:
    this.grid.AddNewItem();
    break;
   case GridViewToolbarCommandType.Edit:
    this.ToolbarStartEdit();
    break;
   case GridViewToolbarCommandType.Delete:
    this.ToolbarDeleteItem();
    break;
   case GridViewToolbarCommandType.DeleteSelectedRowsOnPage:
    this.ToolbarDeleteSelectedVisibleItems();
    break;
   case GridViewToolbarCommandType.Refresh:
    this.grid.Refresh();
    break;
   case GridViewToolbarCommandType.ClearGrouping:
    this.ToolbarClearGrouping();
    break;
   case GridViewToolbarCommandType.Update:
    this.grid.UpdateEdit();
    break;
   case GridViewToolbarCommandType.Cancel:
    this.grid.CancelEdit();
    break;
   default:
    ASPx.GridToolbarHelper.prototype.ProcessToolbarItemClick.call(this, e);
    break;
  }
 },
 ToolbarShowGroupPanel: function(show) {
  this.SendToolbarCallback([ "ShowGroupPanel", show ? 1 : 0 ]);
 },
 ToolbarShowSearchPanel: function(show) {
  this.SendToolbarCallback([ "ShowSearchPanel", show ? 1 : 0 ]);
 },
 ToolbarShowFilterRow: function(show) {
  this.SendToolbarCallback([ "ShowFilterRow", show ? 1 : 0 ]);
 },
 ToolbarShowFilterRowMenu: function(show) {
  this.SendToolbarCallback([ "ShowFilterRowMenu", show ? 1 : 0 ]);
 },
 ToolbarShowFooter: function(show) {
  this.SendToolbarCallback([ "ShowFooter", show ? 1 : 0 ]);
 },
 ToolbarClearGrouping: function() {
  this.SendToolbarCallback([ "ClearGrouping" ]);
 },
 ToolbarClearSorting: function() {
  this.SendToolbarCallback([ "ClearSorting" ]);
 },
 IsUpdateEditItem: function(item) {
  switch(item.name) {
   case GridViewToolbarCommandType.Update:
   case GridViewToolbarCommandType.Cancel:
    return true;
  }
  return false;
 },
 IsShowCustomizationWindowItem: function(item) {
  return item.name === GridViewToolbarCommandType.ShowCustomizationWindow;
 },
 RefreshItemText: function(item) {
  if(item.name === GridViewToolbarCommandType.DeleteSelectedRowsOnPage)
   this.RefreshSelectionBasedItemText(item, this.GetSelectedVisibleGridItemCount());
 },
 GetToolbarItemEnabled: function(item){
  switch(item.name) {
   case GridViewToolbarCommandType.Edit:
    return this.GetEditItemEnabled();
   case GridViewToolbarCommandType.Delete:
    return this.GetDeleteItemEnabled();
   case GridViewToolbarCommandType.DeleteSelectedRowsOnPage:
    return this.GetDeleteSelectedRowsOnPageItemEnabled();
   case GridViewToolbarCommandType.ExpandRow:
    return this.GetExpandRowItemEnabled();
   case GridViewToolbarCommandType.CollapseRow:
    return this.GetCollapseRowwItemEnabled();
   case GridViewToolbarCommandType.ExpandDetailRow:
    return this.GetExpandDetailRowEnabled();
   case GridViewToolbarCommandType.CollapseDetailRow:
    return this.GetCollapseDetailRowEnabled();
  }
  return null;
 },
 GetEditItemEnabled: function(){
  var focusedIndex = this.GetFocusedItemIndex();
  return this.grid.allowEdit && !this.IsGroupRow(focusedIndex) && (this.HasBatchEditFocusedCell() || !this.IsEditingItem(focusedIndex));
 },
 GetDeleteItemEnabled: function(){
  var focusedIndex = this.GetFocusedItemIndex();
  return this.grid.allowDelete && !this.IsGroupRow(focusedIndex) && (this.HasBatchEditFocusedCell() || !this.IsEditingItem(focusedIndex));
 },
 GetDeleteSelectedRowsItemEnabled: function() {
  return this.grid.allowDelete && this.GetSelectedGridItemCount() > 0;
 },
 GetDeleteSelectedRowsOnPageItemEnabled: function() {
  return this.grid.allowDelete && this.GetSelectedVisibleGridItemCount() > 0;
 },
 GetExpandRowItemEnabled: function(){
  var focusedIndex = this.GetFocusedItemIndex();
  return this.IsGroupRow(focusedIndex) && !this.IsGroupRowExpanded(focusedIndex);
 },
 GetCollapseRowwItemEnabled: function(){
  var focusedIndex = this.GetFocusedItemIndex();
  return this.IsGroupRow(focusedIndex) && this.IsGroupRowExpanded(focusedIndex);
 },
 GetExpandDetailRowEnabled: function(){
  var focusedIndex = this.GetFocusedItemIndex();
  return !this.IsGroupRow(focusedIndex) && !this.GetDetailRow(focusedIndex);
 },
 GetCollapseDetailRowEnabled: function(){
  var focusedIndex = this.GetFocusedItemIndex();
  return !!this.GetDetailRow(focusedIndex);
 },
 IsGroupRow: function(visibleIndex) {
  return this.control.IsGroupRow(visibleIndex);
 },
 IsGroupRowExpanded: function(visibleIndex){
  return this.control.IsGroupRowExpanded(visibleIndex);
 },
 GetDetailRow: function(visibleIndex){
  return this.control.GetDetailRow(visibleIndex);
 }
});
ASPx.GridViewToolbarHelper = GridViewToolbarHelper;
})();
